HDU 4272 LianLianKan 第37届ACM/ICPC 长春赛区网络赛1006题 (搜索)

LianLianKan

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 840    Accepted Submission(s): 280


Problem Description
I like playing game with my friend, although sometimes looks pretty naive. Today I invent a new game called LianLianKan. The game is about playing on a number stack.
Now we have a number stack, and we should link and pop the same element pairs from top to bottom. Each time, you can just link the top element with one same-value element. After pop them from stack, all left elements will fall down. Although the game seems to be interesting, it's really naive indeed.
HDU 4272 LianLianKan 第37届ACM/ICPC 长春赛区网络赛1006题 (搜索)

To prove I am a wisdom among my friend, I add an additional rule to the game: for each top element, it can just link with the same-value element whose distance is less than 6 with it.
Before the game, I want to check whether I have a solution to pop all elements in the stack.
 

 

Input
There are multiple test cases.
The first line is an integer N indicating the number of elements in the stack initially. (1 <= N <= 1000)
The next line contains N integer ai indicating the elements from bottom to top. (0 <= ai <= 2,000,000,000)
 

 

Output
For each test case, output “1” if I can pop all elements; otherwise output “0”.
 

 

Sample Input
2 1 1 3 1 1 1 2 1000000 1
 

 

Sample Output
1 0 0
 

 

Source
 

 

Recommend
liuyiding
 
 
直接暴力DFS。很简单。。。注意细节。还有前面要用map来判断,否则会超时。
听说比较坑的题目。。。好像现在距离取5和6都可以AC了。
#include<stdio.h>

#include<string.h>

#include<iostream>

#include<map>

#include<algorithm>

using namespace std;

const int MAXN=1010;

int a[MAXN];

bool used[MAXN];

int dfs(int n)

{

    while(n>0&&used[n])n--;

    if(n==0)return 1;

    if(n==1)return 0;

    int i=0;

    int j=n-1;

    for(;i<=5;)//这里取i<5和i<=5都可以AC

    {

        if(j<=0)return 0;//没有找到相等的

        if(used[j])

        {

            j--;

            continue;

        }

        if(a[n]==a[j])

        {

            used[j]=true;

            if(dfs(n-1)) return 1;

            used[j]=false;

        }

        i++;

        j--;

    }

    return 0;

}

map<int,int>mp;

int main()

{

    int n;

    while(scanf("%d",&n)!=EOF)

    {

        mp.clear();

        for(int i=1;i<=n;i++)

        {

            scanf("%d",&a[i]);

            used[i]=false;

            mp[a[i]]++;

        }

        if(n&1)

        {

            printf("0\n");

            continue;

        }

        int t=1;

        //加个map判断就是0ms,否则就是TLE

        map<int,int>::iterator it;

        for(it=mp.begin();it!=mp.end();it++)

        {

            if((it->second)%2==1)

            {

                t=0;

                break;

            }

        }

        if(t==0)

        {

            printf("0\n");

            continue;

        }

        printf("%d\n",dfs(n));

    }

    return 0;

}

 

你可能感兴趣的:(ICPC)